<?php
class ControllerPossettingCashregister extends Controller {
 	private $error = array();
	public function index() {
			
		$this->load->language('possetting/cash_register');
		
		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('possetting/cash_register');
		
		$this->getList();
	}

 	public function getList() {
		$this->load->language('possetting/cash_register');

		
		if (isset($this->request->get['filter_posuser'])) {
			$filter_posuser = $this->request->get['filter_posuser'];
		} else {
			$filter_posuser = null;
		}

		if (isset($this->request->get['filter_date_form'])) {
			$filter_date_form = $this->request->get['filter_date_form'];
		} else {
			$filter_date_form = null;
		}

	
		if (isset($this->request->get['sort'])) {
			$sort = $this->request->get['sort'];
		} else {
		 	$sort = 'opening_balance_id';
		}
	 
		if (isset($this->request->get['order'])) {
			$order = $this->request->get['order'];
		} else {
		 	$order = 'DESC';
		}
	 
		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}
		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}
	 	
		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}
			 
		if (isset($this->request->post['selected'])) {
			$data['selected'] = (array)$this->request->post['selected'];
		} else {
			$data['selected'] = array();
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('possetting/cash_register', 'user_token=' . $this->session->data['user_token'] . $url, true)
		);

		$data['cashregisters'] = array();

		$filter_data = array(
			'filter_posuser'   => $filter_posuser,
			'filter_date_form' => $filter_date_form,
			'sort'  => $sort,
			'order' => $order,
			'start' => ($page - 1) * $this->config->get('config_limit_admin'),
			'limit' => $this->config->get('config_limit_admin')
		);
		
		$taxs_total = $this->model_possetting_cash_register->getTotalCashRegister($filter_data);
		$results = $this->model_possetting_cash_register->getCashRegisters($filter_data);
	
		$ordertotal=0;
		$openingtotal=0;
		$cashintotal=0;


		if(isset($filter_date_form)) {
			$date_add = $filter_date_form;
		} else {
			$date_add = date('Y-m-d');;
		}
	
		foreach ($results as $result) {

			$order_amount = $this->model_possetting_cash_register->getuserOrderAmount($result['user_id'], $date_add);

			
			$ordertotal+=$order_amount['total'];

			$openingtotal+=$result['amount'];

			$cashintotal+=$result['cash_in'];
			
			$data['cashregisters'][] = array(
				'opening_balance_id' => $result['opening_balance_id'],
				'username' => $result['username'],
				'opening_amount'   => $this->currency->format($result['amount'], $this->config->get('config_currency'), $this->config->get('currency_value')),
				'order_amount'   => $this->currency->format($order_amount['total'], $this->config->get('config_currency'), $this->config->get('currency_value')),
				'adminuser'   => $result['adminuser'],
				'cash_in'   => $this->currency->format($result['cash_in'], $this->config->get('config_currency'), $this->config->get('currency_value'))
			);	
		}


		$data['opening_total']=$this->currency->format($openingtotal, $this->config->get('config_currency'), $this->config->get('currency_value'));
		$data['order_total']=$this->currency->format($ordertotal, $this->config->get('config_currency'), $this->config->get('currency_value'));
		$data['cashin_total']=$this->currency->format($cashintotal, $this->config->get('config_currency'), $this->config->get('currency_value'));

   
		$data['heading_title']        = $this->language->get('heading_title');

		$data['text_list']            = $this->language->get('text_list');
		$data['text_no_results'] 	  = $this->language->get('text_no_results');
		$data['text_confirm'] 		  = $this->language->get('text_confirm');
		$data['text_nooption'] 		  = $this->language->get('text_nooption');
		$data['text_select'] 		  = $this->language->get('text_select');
		$data['text_print'] 		  = $this->language->get('text_print');

		$data['column_order_id']	  = $this->language->get('column_order_id');
		$data['column_product']	      = $this->language->get('column_product');
		$data['column_date']	      = $this->language->get('column_date');
		$data['column_payment_method']= $this->language->get('column_payment_method');
		$data['column_total']  		  =	$this->language->get('column_total');
		$data['column_form']	      = $this->language->get('column_form');
		$data['column_to']	          = $this->language->get('column_to');
		$data['column_grand']	      = $this->language->get('column_grand');

		$data['button_delete'] 		  = $this->language->get('button_delete');
		$data['button_filter'] 		  = $this->language->get('button_filter');
		$data['button_save'] 		  = $this->language->get('button_save');
		$data['user_token']           = $this->session->data['user_token'];
		
		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$url = '';

		if (isset($this->request->get['filter_posuser'])) {
			$url .= '&filter_posuser=' . $this->request->get['filter_posuser'];
		}

		if (isset($this->request->get['filter_date_form'])) {
			$url .= '&filter_date_form=' . $this->request->get['filter_date_form'];
		}


		
		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}
	  
		$data['sort_date'] 			= $this->url->link('possetting/cash_register', 'user_token=' . $this->session->data['user_token'] . '&sort=date' . $url, true);
		$data['sort_total']   		= $this->url->link('possetting/cash_register', 'user_token=' . $this->session->data['user_token'] . '&sort=total' . $url, true);
		
		if (isset($this->session->data['success'])) {
		 $data['success'] = $this->session->data['success'];
		unset($this->session->data['success']);
		} else {
		$data['success'] = '';
		}


		if (isset($this->request->get['filter_posuser'])) {
			$url .= '&filter_posuser=' . $this->request->get['filter_posuser'];
		}

		if (isset($this->request->get['filter_date_form'])) {
			$url .= '&filter_date_form=' . $this->request->get['filter_date_form'];
		}



		$data['sort']  = $sort;
		$data['order'] = $order;
		   
		$url = '';

	
		if (isset($this->request->get['filter_posuser'])) {
			$url .= '&filter_posuser=' . $this->request->get['filter_posuser'];
		}

		if (isset($this->request->get['filter_date_form'])) {
			$url .= '&filter_date_form=' . $this->request->get['filter_date_form'];
		}


		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}
        
		$pagination 	   = new Pagination();
		$pagination->total = $taxs_total;
		$pagination->page  = $page;
		$pagination->limit = $this->config->get('config_limit_admin');
		$pagination->url   = $this->url->link('possetting/cash_register', 'user_token=' . $this->session->data['user_token'] . $url . '&page={page}', true);
		$data['pagination']= $pagination->render();

		$data['results'] = sprintf($this->language->get('text_pagination'), ($taxs_total) ? (($page - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($page - 1) * $this->config->get('config_limit_admin')) > ($taxs_total - $this->config->get('config_limit_admin'))) ? $taxs_total : ((($page - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $taxs_total, ceil($taxs_total / $this->config->get('config_limit_admin')));

		$data['filter_posuser'] = $filter_posuser;
		$data['sort'] = $sort;
		$data['order'] = $order;
		
		if(isset($filter_date_form)) {
			$data['filter_date_form'] = $filter_date_form;
		} else {
			$data['filter_date_form'] 	= date('Y-m-d');;
		}

		$data['header']      = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer']      = $this->load->controller('common/footer');
		$this->response->setOutput($this->load->view('possetting/cash_register', $data));
	}

	public function autocompleteuser() {
		$json = array();

		if (isset($this->request->get['filter_name'])) {
			$this->load->model('possetting/cash_register');

			if (isset($this->request->get['filter_name'])) {
				$filter_name = $this->request->get['filter_name'];
			} else {
				$filter_name = '';
			}

			if (isset($this->request->get['limit'])) {
				$limit = $this->request->get['limit'];
			} else {
				$limit = 5;
			}

			$filter_data = array(
				'filter_name'  => $filter_name,
				'start'        => 0,
				'limit'        => $limit
			);

			$results = $this->model_possetting_cash_register->getPosusers($filter_data);

				foreach ($results as $result) {

				$json[] = array(
					'user_id' => $result['user_id'],
					'name'      => $result['username']
				);
			}
		}
		

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}

		public function addbalance() {
			$this->load->model('possetting/cash_register');
			$this->load->language('possetting/cash_register');
			$json=array();

			if(empty($this->request->post['cash'])) {
			   $json['error'] = 'Please Enter amount!';
			}elseif(empty($this->request->post['posuser_id'])){
				 $json['error'] = 'Please Select Cashier!';
			}
			if(!$json){
				$this->model_possetting_cash_register->addCash($this->request->post);
				$json['success'] = $this->language->get('text_success');
			}
			 
			$this->response->addHeader('Content-Type: application/json');
			$this->response->setOutput(json_encode($json));
		}

}