<?php
class ControllerPossettingDaybook extends Controller {
 	private $error = array();
	public function index() {
			
		$this->load->language('possetting/daybook');
		
		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('possetting/daybook');
		
		$this->getList();
	}
		
 	public function getList() {
		$this->load->language('possetting/daybook');

		
		if (isset($this->request->get['filter_posuser'])) {
			$filter_posuser = $this->request->get['filter_posuser'];
		} else {
			$filter_posuser = null;
		}

		if (isset($this->request->get['filter_date_form'])) {
			$filter_date_form = $this->request->get['filter_date_form'];
		} else {
			$filter_date_form = date('Y-m-d');
		}
		if (isset($this->request->get['filter_date_to'])) {
			$filter_date_to = $this->request->get['filter_date_to'];
		} else {
			$filter_date_to = date('Y-m-d');
		}
	
		if (isset($this->request->get['sort'])) {
			$sort = $this->request->get['sort'];
		} else {
		 	$sort = 'opening_balance_id';
		}
	 
		if (isset($this->request->get['order'])) {
			$order = $this->request->get['order'];
		} else {
		 	$order = 'DESC';
		}
	 
		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}
		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}
	 	
		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}
			 
		if (isset($this->request->post['selected'])) {
			$data['selected'] = (array)$this->request->post['selected'];
		} else {
			$data['selected'] = array();
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('possetting/daybook', 'user_token=' . $this->session->data['user_token'] . $url, true)
		);

		$data['daybooks'] = array();

		$filter_data = array(
			'filter_posuser'   => $filter_posuser,
			'filter_date_form' => $filter_date_form,
			'filter_date_to' => $filter_date_to,
			'sort'  => $sort,
			'order' => $order,
			'start' => ($page - 1) * $this->config->get('config_limit_admin'),
			'limit' => $this->config->get('config_limit_admin')
		);
		
	
	
		$ordertotal=0;
		$openingtotal=0;
		$cashintotal=0;


		
		
			$setting_paymentmethods = $this->config->get('setting_paymentmethod');
			$data['paymentmethods'] = array();
			if(is_array($setting_paymentmethods)) {
				foreach ($setting_paymentmethods as $setting_paymentmethod) {
				$amount =	$this->model_possetting_daybook->getpayment($filter_data,$setting_paymentmethod['code']);
					$data['paymentmethods'][] = array(
						'name' 	=> $setting_paymentmethod['name'],
						'amount' =>$this->currency->format($amount,$this->config->get('config_currency'),$this->config->get('currency_value')),

					);
					$openingtotal+=$amount;
				}
			}
		$opening_amount = $returnsale = $this->model_possetting_daybook->getopening($filter_data);
		$data['opening_amount']=$this->currency->format($opening_amount,$this->config->get('config_currency'),$this->config->get('currency_value'));
		$openingtotal+=$opening_amount;

		$cashin = $returnsale = $this->model_possetting_daybook->getcashin($filter_data);
		$data['cashin']=$this->currency->format($cashin,$this->config->get('config_currency'),$this->config->get('currency_value'));
		$cashintotal+=$cashin;

		$returnsale = $this->model_possetting_daybook->getReturn($filter_data);
		$cashintotal+=$returnsale;
		 $data['returnsale'] =$this->currency->format($returnsale,$this->config->get('config_currency'),$this->config->get('currency_value')) ;
	
		$data['opening_total']=$this->currency->format($openingtotal, $this->config->get('config_currency'), $this->config->get('currency_value'));
		$data['order_total']=$this->currency->format($ordertotal, $this->config->get('config_currency'), $this->config->get('currency_value'));
		$data['cashin_total']=$this->currency->format($cashintotal, $this->config->get('config_currency'), $this->config->get('currency_value'));

   
		

		$data['user_token']           = $this->session->data['user_token'];
		
		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$url = '';

		if (isset($this->request->get['filter_posuser'])) {
			$url .= '&filter_posuser=' . $this->request->get['filter_posuser'];
		}

		if (isset($this->request->get['filter_date_form'])) {
			$url .= '&filter_date_form=' . $this->request->get['filter_date_form'];
		}
		if (isset($this->request->get['filter_date_to'])) {
			$url .= '&filter_date_to=' . $this->request->get['filter_date_to'];
		}
		

	
		if (isset($this->session->data['success'])) {
		 $data['success'] = $this->session->data['success'];
		unset($this->session->data['success']);
		} else {
		$data['success'] = '';
		}


		if (isset($this->request->get['filter_posuser'])) {
			$url .= '&filter_posuser=' . $this->request->get['filter_posuser'];
		}

		if (isset($this->request->get['filter_date_form'])) {
			$url .= '&filter_date_form=' . $this->request->get['filter_date_form'];
		}
		if (isset($this->request->get['filter_date_to'])) {
			$url .= '&filter_date_to=' . $this->request->get['filter_date_to'];
		}
		

		   
		$url = '';

	
		if (isset($this->request->get['filter_posuser'])) {
			$url .= '&filter_posuser=' . $this->request->get['filter_posuser'];
		}

		if (isset($this->request->get['filter_date_form'])) {
			$url .= '&filter_date_form=' . $this->request->get['filter_date_form'];
		}
		if (isset($this->request->get['filter_date_to'])) {
			$url .= '&filter_date_to=' . $this->request->get['filter_date_to'];
		}

	
		$data['filter_posuser'] = $filter_posuser;
		$data['sort'] = $sort;
		$data['order'] = $order;
		
		if(isset($filter_date_form)) {
			$data['filter_date_form'] = $filter_date_form;
		} else {
			$data['filter_date_form'] 	= date('Y-m-d');;
		}
		if(isset($filter_date_to)) {
			$data['filter_date_to'] = $filter_date_to;
		} else {
			$data['filter_date_to'] 	= date('Y-m-d');;
		}
		
		$data['salereports'] = $this->url->link('possetting/daybook/filterreport', 'user_token=' . $this->session->data['user_token']. $url, true);
		$data['header']      = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer']      = $this->load->controller('common/footer');
		$this->response->setOutput($this->load->view('possetting/daybook', $data));
	}
	public function filterreport() {
		$this->load->language('possetting/daybook');
		$this->load->model('possetting/daybook');
	

		$data['sellreports'] = array();
		
		
		if (isset($this->request->get['filter_posuser'])) {
			$filter_posuser = $this->request->get['filter_posuser'];
		} else {
			$filter_posuser = null;
		}

		if (isset($this->request->get['filter_date_form'])) {
			$filter_date_form = $this->request->get['filter_date_form'];
		} else {
			$filter_date_form = date('Y-m-d');
		}
		if (isset($this->request->get['filter_date_to'])) {
			$filter_date_to = $this->request->get['filter_date_to'];
		} else {
			$filter_date_to = date('Y-m-d');
		}
	
		if (isset($this->request->get['sort'])) {
			$sort = $this->request->get['sort'];
		} else {
		 	$sort = 'opening_balance_id';
		}
	 
		if (isset($this->request->get['order'])) {
			$order = $this->request->get['order'];
		} else {
		 	$order = 'DESC';
		}
	 
		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}
		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}
	 	
		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}
			 
		if (isset($this->request->post['selected'])) {
			$data['selected'] = (array)$this->request->post['selected'];
		} else {
			$data['selected'] = array();
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('possetting/daybook', 'user_token=' . $this->session->data['user_token'] . $url, true)
		);

		$data['daybooks'] = array();

		$filter_data = array(
			'filter_posuser'   => $filter_posuser,
			'filter_date_form' => $filter_date_form,
			'filter_date_to' => $filter_date_to,
			'sort'  => $sort,
			'order' => $order,
			'start' => ($page - 1) * $this->config->get('config_limit_admin'),
			'limit' => $this->config->get('config_limit_admin')
		);
		
		$taxs_total = '';
	//	$results = $this->model_possetting_daybook->getdaybooks($filter_data);
	
		$ordertotal=0;
		$openingtotal=0;
		$cashintotal=0;


		
		
			$setting_paymentmethods = $this->config->get('setting_paymentmethod');
			$data['paymentmethods'] = array();
			if(is_array($setting_paymentmethods)) {
				foreach ($setting_paymentmethods as $setting_paymentmethod) {
				$amount =	$this->model_possetting_daybook->getpayment($filter_data,$setting_paymentmethod['code']);
					$data['paymentmethods'][] = array(
						'name' 	=> $setting_paymentmethod['name'],
						'amount' =>$this->currency->format($amount,$this->config->get('config_currency'),$this->config->get('currency_value')),

					);
					$openingtotal+=$amount;
				}
			}
		$opening_amount = $returnsale = $this->model_possetting_daybook->getopening($filter_data);
		$data['opening_amount']=$this->currency->format($opening_amount,$this->config->get('config_currency'),$this->config->get('currency_value'));
		$openingtotal+=$opening_amount;

		$cashin = $returnsale = $this->model_possetting_daybook->getcashin($filter_data);
		$data['cashin']=$this->currency->format($cashin,$this->config->get('config_currency'),$this->config->get('currency_value'));
		$cashintotal+=$cashin;

		$returnsale = $this->model_possetting_daybook->getReturn($filter_data);
		$cashintotal+=$returnsale;
		 $data['returnsale'] =$this->currency->format($returnsale,$this->config->get('config_currency'),$this->config->get('currency_value')) ;
	
		$data['opening_total']=$this->currency->format($openingtotal, $this->config->get('config_currency'), $this->config->get('currency_value'));
		$data['order_total']=$this->currency->format($ordertotal, $this->config->get('config_currency'), $this->config->get('currency_value'));
		$data['cashin_total']=$this->currency->format($cashintotal, $this->config->get('config_currency'), $this->config->get('currency_value'));

   
		

		$data['user_token']           = $this->session->data['user_token'];
		
		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$url = '';

		if (isset($this->request->get['filter_posuser'])) {
			$url .= '&filter_posuser=' . $this->request->get['filter_posuser'];
		}

		if (isset($this->request->get['filter_date_form'])) {
			$url .= '&filter_date_form=' . $this->request->get['filter_date_form'];
		}
		if (isset($this->request->get['filter_date_to'])) {
			$url .= '&filter_date_to=' . $this->request->get['filter_date_to'];
		}
		

	
		if (isset($this->session->data['success'])) {
		 $data['success'] = $this->session->data['success'];
		unset($this->session->data['success']);
		} else {
		$data['success'] = '';
		}


		if (isset($this->request->get['filter_posuser'])) {
			$url .= '&filter_posuser=' . $this->request->get['filter_posuser'];
		}

		if (isset($this->request->get['filter_date_form'])) {
			$url .= '&filter_date_form=' . $this->request->get['filter_date_form'];
		}
		if (isset($this->request->get['filter_date_to'])) {
			$url .= '&filter_date_to=' . $this->request->get['filter_date_to'];
		}
		

		   
		$url = '';

	
		if (isset($this->request->get['filter_posuser'])) {
			$url .= '&filter_posuser=' . $this->request->get['filter_posuser'];
		}

		if (isset($this->request->get['filter_date_form'])) {
			$url .= '&filter_date_form=' . $this->request->get['filter_date_form'];
		}
		if (isset($this->request->get['filter_date_to'])) {
			$url .= '&filter_date_to=' . $this->request->get['filter_date_to'];
		}

	
		$data['filter_posuser'] = $filter_posuser;
		$data['sort'] = $sort;
		$data['order'] = $order;
		
		if(isset($filter_date_form)) {
			$data['filter_date_form'] = $filter_date_form;
		} else {
			$data['filter_date_form'] 	= date('Y-m-d');;
		}
		if(isset($filter_date_to)) {
			$data['filter_date_to'] = $filter_date_to;
		} else {
			$data['filter_date_to'] 	= date('Y-m-d');;
		}
		
		$data['header']      = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer']      = $this->load->controller('common/footer');
		$this->response->setOutput($this->load->view('possetting/dayreport_print', $data));
	}

}