<?php
class ControllerPossettingPartialreport extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('possetting/partialreport');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('possetting/partialreport');

		$this->getList();

	}
	protected function getList() {

		if (isset($this->request->get['filter_order_id'])) {
			$filter_order_id = $this->request->get['filter_order_id'];
		} else {
			$filter_order_id = null;
		}
		if (isset($this->request->get['filter_customer'])) {
			$filter_customer = $this->request->get['filter_customer'];
		} else {
			$filter_customer = null;
		}

		if (isset($this->request->get['filter_start_date'])) {
			$filter_start_date = $this->request->get['filter_start_date'];
		} else {
			$filter_start_date = null;
		}

		if (isset($this->request->get['filter_end_date'])) {
			$filter_end_date = $this->request->get['filter_end_date'];
		} else {
			$filter_end_date = null;
		}

		if (isset($this->request->get['sort'])) {
			$sort = $this->request->get['sort'];
		} else {
			$sort = 'name';
		}

		if (isset($this->request->get['order'])) {
			$order = $this->request->get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort='.$this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order='.$this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page='.$this->request->get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token='.$this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('possetting/partialreport', 'user_token='.$this->session->data['user_token'].$url, true)
		);

		$data['orders'] = array();

		$filter_data = array(
			'filter_order_id'   => $filter_order_id,
			'filter_customer'   => $filter_customer,
			'filter_start_date' => $filter_start_date,
			'filter_end_date'   => $filter_end_date,
			'sort'              => $sort,
			'order'             => $order,
			'start'             => ($page-1)*$this->config->get('config_limit_admin'),
			'limit'             => $this->config->get('config_limit_admin')
		);

		$partialreport_total = $this->model_possetting_partialreport->getTotalpartialreport($filter_data);

		$results = $this->model_possetting_partialreport->getPartialreports($filter_data);

		foreach ($results as $result) {

			$customer_info = $this->model_possetting_partialreport->getCustomer($result['order_id']);

			if (!empty($customer_info)) {
				$customer = $customer_info['firstname'].' '.$customer_info['lastname'];
			} else {
				$customer = '';
			}

			$order_total = $this->model_possetting_partialreport->getorderTotal($result['order_id']);
			if ($order_total) {
				$totals = $this->currency->format($order_total['total'], $order_total['currency_code'], $order_total['currency_value']);
				$total  = $order_total['total'];
			} else {
				$total = '';
			}

			$amounts  = $this->model_possetting_partialreport->getamountanddate($result['order_id']);
			$resultss = array();
			foreach ($amounts as $amount) {
				$resultss[] = array(
					'partial_amount' => $this->currency->format($amount['partial_amount'], $order_total['currency_code'], $order_total['currency_value']),
					'date'           => date('Y-m-d', strtotime($amount['date_added'])),

				);
			}

			$amount_info = $this->model_possetting_partialreport->getamount($result['order_id']);
			$balance     = $this->currency->format($total-$amount_info, $order_total['currency_code'], $order_total['currency_value']);

			$data['orders'][] = array(
				'partial_payment_id' => $result['partial_payment_id'],
				'order_id'           => $result['order_id'],
				'date_added'         => date('Y-m-d', strtotime($order_total['date_added'])),
				'customer'           => $customer,
				'total'              => $totals,
				'balance'            => $balance,
				'resultss'           => $resultss,
			);

		}

		if (isset($this->request->post['selected'])) {
			$data['selected'] = (array) $this->request->post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page='.$this->request->get['page'];
		}

		$data['sort_order_id'] = $this->url->link('possetting/partialreport', 'user_token='.$this->session->data['user_token'].'&sort=order_id'.$url, true);
		$data['sort_customer'] = $this->url->link('possetting/partialreport', 'user_token='.$this->session->data['user_token'].'&sort=customer'.$url, true);

		$data['sort_total']          = $this->url->link('possetting/partialreport', 'user_token='.$this->session->data['user_token'].'&sort=total'.$url, true);
		$data['sort_paymenthistory'] = $this->url->link('possetting/partialreport', 'user_token='.$this->session->data['user_token'].'&sort=paymenthistory'.$url, true);

		$data['sort_balance'] = $this->url->link('possetting/partialreport', 'user_token='.$this->session->data['user_token'].'&sort=balance'.$url, true);

		$data['sort_date_added'] = $this->url->link('possetting/partialreport', 'user_token='.$this->session->data['user_token'].'&sort=date_added'.$url, true);

		$url = '';

		if (isset($this->request->get['filter_order_id'])) {
			$url .= '&filter_order_id='.$this->request->get['filter_order_id'];
		}

		if (isset($this->request->get['filter_customer'])) {
			$url .= '&filter_customer='.$this->request->get['filter_customer'];
		}

		if (isset($this->request->get['filter_start_date'])) {
			$url .= '&filter_start_date='.$this->request->get['filter_start_date'];
		}
		if (isset($this->request->get['filter_end_date'])) {
			$url .= '&filter_end_date='.$this->request->get['filter_end_date'];
		}

		if (isset($this->request->get['sort'])) {
			$url .= '&sort='.$this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order='.$this->request->get['order'];
		}
		$pagination        = new Pagination();
		$pagination->total = $partialreport_total;
		$pagination->page  = $page;
		$pagination->limit = $this->config->get('config_limit_admin');
		$pagination->url   = $this->url->link('possetting/partialreport', 'user_token='.$this->session->data['user_token'].$url.'&page={page}', true);

		$data['pagination'] = $pagination->render();

		$data['results']           = sprintf($this->language->get('text_pagination'), ($partialreport_total)?(($page-1)*$this->config->get('config_limit_admin'))+1:0, ((($page-1)*$this->config->get('config_limit_admin')) > ($partialreport_total-$this->config->get('config_limit_admin')))?$partialreport_total:((($page-1)*$this->config->get('config_limit_admin'))+$this->config->get('config_limit_admin')), $partialreport_total, ceil($partialreport_total/$this->config->get('config_limit_admin')));
		$data['filter_order_id']   = $filter_order_id;
		$data['filter_customer']   = $filter_customer;
		$data['filter_start_date'] = $filter_start_date;
		$data['filter_end_date']   = $filter_end_date;
		$data['sort']              = $sort;
		$data['order']             = $order;
		$data['user_token']        = $this->session->data['user_token'];
		$data['print']             = $this->url->link('possetting/partialreport/print', 'user_token='.$this->session->data['user_token'].$url, true);
		$data['header']            = $this->load->controller('common/header');
		$data['column_left']       = $this->load->controller('common/column_left');
		$data['footer']            = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('possetting/partialreport_list', $data));
	}

	public function print() {
		$data['user_token'] = $this->session->data['user_token'];
		$this->load->language('possetting/partialreport');
		$this->load->model('possetting/partialreport');

		if (isset($this->request->get['filter_order_id'])) {
			$filter_order_id = $this->request->get['filter_order_id'];
		} else {
			$filter_order_id = null;
		}
		if (isset($this->request->get['filter_customer'])) {
			$filter_customer = $this->request->get['filter_customer'];
		} else {
			$filter_customer = null;
		}

		if (isset($this->request->get['filter_start_date'])) {
			$filter_start_date = $this->request->get['filter_start_date'];
		} else {
			$filter_start_date = null;
		}

		if (isset($this->request->get['filter_end_date'])) {
			$filter_end_date = $this->request->get['filter_end_date'];
		} else {
			$filter_end_date = null;
		}

		if (isset($this->request->get['sort'])) {
			$sort = $this->request->get['sort'];
		} else {
			$sort = 'name';
		}

		if (isset($this->request->get['order'])) {
			$order = $this->request->get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort='.$this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order='.$this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page='.$this->request->get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token='.$this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('possetting/partialreport', 'user_token='.$this->session->data['user_token'].$url, true)
		);

		$data['currency_value'] = array();

		$filter_data = array(
			'filter_order_id'   => $filter_order_id,
			'filter_customer'   => $filter_customer,
			'filter_start_date' => $filter_start_date,
			'filter_end_date'   => $filter_end_date,
			'sort'              => $sort,
			'order'             => $order,
			'start'             => ($page-1)*$this->config->get('config_limit_admin'),
			'limit'             => $this->config->get('config_limit_admin')
		);
		$data['title'] = $this->language->get('text_Partial_Report');

		if (isset($this->request->post['selected'])) {
			$partial_payment_ids = $this->request->post['selected'];
		} elseif (isset($this->request->get['order_id'])) {
			$partial_payment_ids[] = $this->request->get['order_id'];
		}
		if (!empty($partial_payment_ids)) {
			foreach ($partial_payment_ids as $partial_payment_id) {
				$partialreport_list = $this->model_possetting_partialreport->getpartiallist($partial_payment_id);
				if (!empty($partialreport_list)) {
					$order_id = $partialreport_list['order_id'];
				} else {
					$order_id = "";
				}

				$partialreport_total = $this->model_possetting_partialreport->getTotalpartialreport($filter_data);
				$results             = $this->model_possetting_partialreport->getPartialreports($filter_data);

				$customer_info = $this->model_possetting_partialreport->getCustomer($order_id);

				if (!empty($customer_info)) {
					$customer = $customer_info['firstname'].' '.$customer_info['lastname'];
				} else {
					$customer = '';
				}

				$order_total = $this->model_possetting_partialreport->getorderTotal($order_id);
				if ($order_total) {
					$totals = $this->currency->format($order_total['total'], $order_total['currency_code'], $order_total['currency_value']);
					$total  = $order_total['total'];
				} else {
					$total = '';
				}

				$amounts  = $this->model_possetting_partialreport->getamountanddate($order_id);
				$resultss = array();
				foreach ($amounts as $amount) {
					$resultss[] = array(
						'partial_amount' => $this->currency->format($amount['partial_amount'], $order_total['currency_code'], $order_total['currency_value']),
						'date'           => date('Y-m-d', strtotime($amount['date_added'])),
					);
				}
				$amount_info      = $this->model_possetting_partialreport->getamount($order_id);
				$balance          = $this->currency->format($total-$amount_info, $order_total['currency_code'], $order_total['currency_value']);
				$data['orders'][] = array(
					'order_id'   => $order_id,
					'customer'   => $customer,
					'total'      => $totals,
					'balance'    => $balance,
					'date_added' => date('Y-m-d', strtotime($order_total['date_added'])),
					'resultss'   => $resultss,
				);

			}
		} else {

			$results = $this->model_possetting_partialreport->getPartialreports($filter_data);
			foreach ($results as $result) {
				$customer_info = $this->model_possetting_partialreport->getCustomer($result['order_id']);

				if (!empty($customer_info)) {
					$customer = $customer_info['firstname'].' '.$customer_info['lastname'];
				} else {
					$customer = '';
				}
				$order_total = $this->model_possetting_partialreport->getorderTotal($result['order_id']);
				if ($order_total) {
					$totals = $this->currency->format($order_total['total'], $order_total['currency_code'], $order_total['currency_value']);
					$total  = $order_total['total'];
				} else {
					$total = '';
				}
				$amounts  = $this->model_possetting_partialreport->getamountanddate($result['order_id']);
				$resultss = array();
				foreach ($amounts as $amount) {
					$resultss[] = array(
						'partial_amount' => $this->currency->format($amount['partial_amount'], $order_total['currency_code'], $order_total['currency_value']),
						'date'           => date('d-m-Y', strtotime($amount['date_added'])),

					);
				}
				$amount_info = $this->model_possetting_partialreport->getamount($result['order_id']);
				$balance     = $this->currency->format($total-$amount_info, $order_total['currency_code'], $order_total['currency_value']);

				$data['orders'][] = array(
					'partial_payment_id' => $result['partial_payment_id'],
					'order_id'           => $result['order_id'],
					'date_added'         => date('Y-m-d', strtotime($order_total['date_added'])),
					'customer'           => $customer,
					'total'              => $totals,
					'balance'            => $balance,
					'resultss'           => $resultss,
				);

			}

		}

		$data['heading_title']         = $this->language->get('heading_title');
		$data['column_order_id']       = $this->language->get('column_order_id');
		$data['column_customer']       = $this->language->get('column_customer');
		$data['column_total']          = $this->language->get('column_total');
		$data['column_balance']        = $this->language->get('column_balance');
		$data['column_paymenthistory'] = $this->language->get('column_paymenthistory');
		$data['column_date_added']     = $this->language->get('column_date_added');
		$data['text_amount']           = $this->language->get('text_amount');
		$data['text_date']             = $this->language->get('text_date');
		$data['text_no_results']       = $this->language->get('text_no_results');
		$data['header']                = $this->load->controller('common/header');
		$data['column_left']           = $this->load->controller('common/column_left');
		$data['footer']                = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('possetting/partialreport_print', $data));

	}

	public function customerautocomplete() {
		$json = array();

		if (isset($this->request->get['filter_customer'])) {
			$this->load->model('customer/customer');

			$filter_data = array(
				'filter_name' => $this->request->get['filter_customer'],
				'sort'        => 'customer',
				'order'       => 'ASC',
				'start'       => 0,
				'limit'       => 5,
			);

			$results = $this->model_customer_customer->getCustomers($filter_data);

			foreach ($results as $result) {
				$json[] = array(
					'customer_id' => $result['customer_id'],
					'customer'    => strip_tags(html_entity_decode($result['firstname'].' '.$result['lastname'], ENT_QUOTES, 'UTF-8'))
				);
			}
		}

		$sort_order = array();

		foreach ($json as $key => $value) {
			$sort_order[$key] = $value['customer'];
		}

		array_multisort($sort_order, SORT_ASC, $json);

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}

}