<?php
class ModelPossettingCashregister extends Model {

	public function getCashRegisters($data) {
		$todaydate=date('Y-m-d');
		$sql="SELECT * FROM " . DB_PREFIX . "opening_balance ob LEFT JOIN " . DB_PREFIX . "pos_user pu ON (pu.user_id = ob.user_id) WHERE ob.user_id<>0";
		
	
		if (!empty($data['filter_date_form'])) {
			$sql .= " AND DATE(ob.date_added) = '" . $this->db->escape($data['filter_date_form']) . "'";
		}else{
			$sql .= " AND DATE(ob.date_added) = '" . $todaydate . "'";
		}	

		if (!empty($data['filter_posuser'])) {
		 	$sql .=" and pu.username like '".$this->db->escape($data['filter_posuser'])."%'";
		}
		
		$sort_data = array(
			'ob.opening_balance_id',
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
		 $sql .= " ORDER BY " . $data['sort'];
		} else {
		 $sql .= " ORDER BY ob.opening_balance_id";
		}

		if (isset($data['order']) && ($data['order'] == 'ASC')) {
			$sql .= " ASC";
		} else {
			$sql .= " DESC";
		}

		if (isset($data['start']) || isset($data['limit'])) {

		if ($data['start'] < 0) {
		 	$data['start'] = 0;
		}

		if ($data['limit'] < 1) {
			$data['limit'] = 20;
		}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->rows;
	}

	public function getTotalCashRegister($data) {
		$todaydate=date('Y-m-d');

		$sql="SELECT COUNT(*) AS total FROM " . DB_PREFIX . "opening_balance ob LEFT JOIN " . DB_PREFIX . "pos_user pu ON (pu.user_id = ob.user_id) WHERE ob.user_id<>0";


		if (!empty($data['filter_date_form'])) {
			$sql .= " AND DATE(ob.date_added) = '" . $this->db->escape($data['filter_date_form']) . "'";
		}else{
			$sql .= " AND DATE(ob.date_added) = '" . $todaydate . "'";
		}

		if (!empty($data['filter_posuser'])) {
		 $sql .=" and pu.username like '".$this->db->escape($data['filter_posuser'])."%'";
		}


		$query = $this->db->query($sql);
		return $query->row['total'];
	}



	public function getPosusers($data) {
		$sql="SELECT * FROM " . DB_PREFIX . "pos_user WHERE user_id<>0";

		
		if (!empty($data['filter_name'])) {
		 	$sql .=" and username like '".$this->db->escape($data['filter_name'])."%'";
		}

		$sort_data = array(
			'user_id',
		);

		 $sql .= " ORDER BY user_id DESC";


		if (isset($data['start']) || isset($data['limit'])) {

		if ($data['start'] < 0) {
		 	$data['start'] = 0;
		}

		if ($data['limit'] < 1) {
			$data['limit'] = 20;
		}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->rows;
	}

	public function getuserOrderAmount($user_id, $date_add){
		
		$implode = array();

		foreach ($this->config->get('config_complete_status') as $order_status_id) {
			$implode[] = "'" . (int)$order_status_id . "'";
		}
		
		$sql ="SELECT sum(o.total) as total FROM `" . DB_PREFIX . "order` o LEFT JOIN " . DB_PREFIX . "pos_order po ON (o.order_id = po.order_id) WHERE po.user_id = '" . (int)$user_id . "' AND o.order_status_id IN(" . implode(",", $implode) . ") AND DATE(o.date_added) = '" . $date_add . "'";
				
		$query = $this->db->query($sql);
		if(isset($query->row)){
			return $query->row;
		} else {
			return 0;
		}
		
	}
	public function getSplitOrderAmount($order_id){
		$sql ="SELECT sum(amount) as amount FROM `" . DB_PREFIX . "pos_split_payment` WHERE order_id = '" . (int)$order_id . "' AND method = 'cod'";
				
		$query = $this->db->query($sql);
		if(isset($query->row['amount'])){
			return $query->row['amount'];
		} else {
			return 0;
		}
		
	}
	public function getUserOrder($user_id){
		$sql ="SELECT sum(amount) as amount FROM `" . DB_PREFIX . "pos_order` WHERE user_id = '" . (int)$user_id . "'";
				
		$query = $this->db->query($sql);
		return $query->rows;
		
	}

	public function addCash($data) {
		$adminuser=$this->user->getUserName();
		$this->db->query("UPDATE " . DB_PREFIX . "opening_balance SET  cash_in = (cash_in + " . (float)$data['cash'] . "), adminuser = '" . $adminuser . "' WHERE user_id = '" . (int)$data['posuser_id'] . "' AND  date_added = '" . $data['date_add'] . "'");

	}


}