<?php
class ModelPossettingCategorysale extends Model {

	public function getcategorysaleReports($data) {
		$sql="SELECT sum(op.total) AS total,cd.name,pc.category_id FROM " . DB_PREFIX . "order_product op LEFT JOIN " . DB_PREFIX . "product_to_category pc ON (op.product_id = pc.product_id) LEFT JOIN " . DB_PREFIX . "order o ON (o.order_id = op.order_id) LEFT JOIN " . DB_PREFIX . "category_description cd ON (cd.category_id = pc.category_id)";

	
		$implode = array();

		foreach ($this->config->get('config_complete_status') as $order_status_id) {
			$implode[] = "'" . (int)$order_status_id . "'";
		}
		$sql .= " WHERE o.order_status_id IN(" . implode(",", $implode) . ")";
		$sql .= " AND cd.language_id = '" . (int)$this->config->get('config_language_id') . "'";


		if (!empty($data['filter_category'])) {
			$sql .= " AND cd.name LIKE '%" . $this->db->escape($data['filter_category']) . "%'";

		}
		
		if (!empty($data['filter_date_form'])) {
			$sql .= " AND DATE(o.date_added) >= '" . $this->db->escape($data['filter_date_form']) . "'";
		}

		if (!empty($data['filter_date_to'])) {
			$sql .= " AND DATE(o.date_added) <= '" . $this->db->escape($data['filter_date_to']) . "'";
		}
		
		$sql .= " group by pc.category_id";	

		$sort_data = array(
			'cd.name',
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
		 $sql .= " ORDER BY " . $data['sort'];
		} else {
		 $sql .= " ORDER BY cd.name";
		}

		if (isset($data['order']) && ($data['order'] == 'ASC')) {
			$sql .= " ASC";
		} else {
			$sql .= " DESC";
		}

		if (isset($data['start']) || isset($data['limit'])) {

		if ($data['start'] < 0) {
		 	$data['start'] = 0;
		}

		if ($data['limit'] < 1) {
			$data['limit'] = 20;
		}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->rows;
	}

	public function getcategorysaleProducts($category_id) {
		//$sql="SELECT DISTINCT op.product_id, op.name FROM " . DB_PREFIX . "order_product op LEFT JOIN " . DB_PREFIX . "product_to_category pc ON (op.product_id = pc.product_id)  WHERE pc.category_id = '" . (int)$category_id . "'";

		$sql="SELECT op.name, sum(op.total) as price FROM " . DB_PREFIX . "order_product op LEFT JOIN " . DB_PREFIX . "product_to_category pc ON (op.product_id = pc.product_id) LEFT JOIN " . DB_PREFIX . "order o ON (o.order_id = op.order_id)";

	
		$implode = array();

		foreach ($this->config->get('config_complete_status') as $order_status_id) {
			$implode[] = "'" . (int)$order_status_id . "'";
		}
		$sql .= " WHERE o.order_status_id IN(" . implode(",", $implode) . ")";
		$sql .= " AND pc.category_id = '" . (int)$category_id . "'";

		$sql .= " group by op.name";	

		$query = $this->db->query($sql);

		return $query->rows;
	}


	public function getTotalTaxReport($data) {
		
		$sql="SELECT sum(op.total) AS total,pc.category_id,cd.name FROM " . DB_PREFIX . "order_product op LEFT JOIN " . DB_PREFIX . "product_to_category pc ON (op.product_id = pc.product_id) LEFT JOIN " . DB_PREFIX . "order o ON (o.order_id = op.order_id) LEFT JOIN " . DB_PREFIX . "category_description cd ON (cd.category_id = pc.category_id)";

	
		$implode = array();

		foreach ($this->config->get('config_complete_status') as $order_status_id) {
			$implode[] = "'" . (int)$order_status_id . "'";
		}
		$sql .= " WHERE o.order_status_id IN(" . implode(",", $implode) . ")";
		$sql .= " AND cd.language_id = '" . (int)$this->config->get('config_language_id') . "'";


		if (!empty($data['filter_category'])) {
			$sql .= " AND cd.name LIKE '%" . $this->db->escape($data['filter_category']) . "%'";

		}
		
		if (!empty($data['filter_date_form'])) {
			$sql .= " AND DATE(o.date_added) >= '" . $this->db->escape($data['filter_date_form']) . "'";
		}

		if (!empty($data['filter_date_to'])) {
			$sql .= " AND DATE(o.date_added) <= '" . $this->db->escape($data['filter_date_to']) . "'";
		}
		
		$sql .= " group by pc.category_id";	

		$sort_data = array(
			'cd.name',
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
		 $sql .= " ORDER BY " . $data['sort'];
		} else {
		 $sql .= " ORDER BY cd.name";
		}

		if (isset($data['order']) && ($data['order'] == 'ASC')) {
			$sql .= " ASC";
		} else {
			$sql .= " DESC";
		}

		if (isset($data['start']) || isset($data['limit'])) {

		if ($data['start'] < 0) {
		 	$data['start'] = 0;
		}

		if ($data['limit'] < 1) {
			$data['limit'] = 20;
		}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->num_rows;
	}


	public function getCategories($data = array()) {
		$sql = "SELECT c.category_id AS category_id, cd1.name AS name FROM " . DB_PREFIX . "category c  LEFT JOIN " . DB_PREFIX . "category_description cd1 ON (c.category_id = cd1.category_id) WHERE cd1.language_id = '" . (int)$this->config->get('config_language_id') . "'";

		if (!empty($data['filter_name'])) {
			$sql .= " AND cd1.name LIKE '%" . $this->db->escape($data['filter_name']) . "%'";
		}

		$sql .= " GROUP BY c.category_id";

		$sort_data = array(
			'name',
			'sort_order'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY sort_order";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->rows;
	}


}