<?php
class ControllerExtensionTmdposLogin extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/tmdpos/login');

		$this->document->setTitle($this->language->get('heading_title'));
	
		if ($this->request->server['HTTPS']) {
			$data['base'] = HTTPS_SERVER;
		} else {
			$data['base'] = HTTP_SERVER;
		}
		$data['heading_title'] = $this->language->get('heading_title');
		/* 03 10 2019 */
		if ($this->request->server['HTTPS']) {
			$server = $this->config->get('config_ssl');
		} else {
			$server = $this->config->get('config_url');
		}
		if (is_file(DIR_IMAGE . $this->config->get('config_icon'))) {
			$this->document->addLink($server . 'image/' . $this->config->get('config_icon'), 'icon');
		}
		/* 03 10 2019 */
		
	
		if ($this->posuser->isLogged()) {
			$this->response->redirect($this->url->link('extension/tmdpos/pos','',true));
		}

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->session->data['pos_user_token'] = token(32);

			
			if (isset($this->request->post['pos_language'])) {
				$this->session->data['language'] = $this->request->post['pos_language'];
			}
			if (isset($this->request->post['pos_currency'])) {
				$this->session->data['currency'] = $this->request->post['pos_currency'];
			}
			
			if (isset($this->request->post['redirect']) && (strpos($this->request->post['redirect'], HTTP_SERVER) === 0 || strpos($this->request->post['redirect'], HTTPS_SERVER) === 0)) {
				$this->response->redirect($this->request->post['redirect']);
			} else {
				$this->response->redirect($this->url->link('extension/tmdpos/pos','',true));
			}
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}

		$data['action'] = $this->url->link('extension/tmdpos/login','', true);

		if (isset($this->request->post['username'])) {
			$data['username'] = $this->request->post['username'];
		} else {
			$data['username'] = '';
		}

		if (isset($this->request->post['password'])) {
			$data['password'] = $this->request->post['password'];
		} else {
			$data['password'] = '';
		}

		if (isset($this->request->get['route'])) {
			$route = $this->request->get['route'];

			unset($this->request->get['route']);
			unset($this->request->get['pos_user_token']);

			$url = '';

			if ($this->request->get) {
				$url .= http_build_query($this->request->get);
			}

			$data['redirect'] = $this->url->link($route, $url,'',true);
		} else {
			$data['redirect'] = '';
		}

		if ($this->config->get('config_password')) {
			$data['forgotten'] = $this->url->link('extension/tmdpos/forgotten', '', true);
		} else {
			$data['forgotten'] = '';
		}

		$data['storelogo'] ='';
		$storelogo = $this->config->get('setting_image');
		$logowidth 	= !empty($this->config->get('setting_logowidth'))?$this->config->get('setting_logowidth'):'100';
		$logoheight = !empty($this->config->get('setting_logoheight'))?$this->config->get('setting_logoheight'):'100';
		$this->load->model('tool/image');
		if (!empty($storelogo)) {
			$data['storelogo'] = $this->model_tool_image->resize($storelogo, $logowidth, $logoheight);
		}

		$this->load->model('setting/store');
		$this->load->model('setting/setting');
		if (!empty($this->session->data['store_id'])) {
			$store_info = $this->model_setting_setting->getSetting('config', $this->session->data['store_id']);
			if (!empty($store_info)) {
				$data['config_name'] 	=$store_info['config_name'];
				$data['config_address'] 	=$store_info['config_address'];
				$data['config_telephone'] 	=$store_info['config_telephone'];
				$data['config_email'] 	=$store_info['config_email'];

				if (!empty($store_info['config_image']) && is_file(DIR_IMAGE . $store_info['config_image'])) {
					$data['storelogo'] = $this->model_tool_image->resize($store_info['config_image'], $logowidth, $logoheight);
				}
			}
		}

		$this->load->model('localisation/language');

		$data['languages'] = array();

		$results = $this->model_localisation_language->getLanguages();

		foreach ($results as $result) {
			if ($result['status']) {
				$data['languages'][] = array(
					'name' => $result['name'],
					'code' => $result['code']
				);
			}
		}


		$this->load->model('localisation/currency');

		$data['currencies'] = array();

		$results = $this->model_localisation_currency->getCurrencies();

		foreach ($results as $result) {
			if ($result['status']) {
				$data['currencies'][] = array(
					'title'        => $result['title'],
					'code'         => $result['code'],
					'symbol_left'  => $result['symbol_left'],
					'symbol_right' => $result['symbol_right']
				);
			}
		}


		$this->response->setOutput($this->load->view('extension/tmdpos/login', $data));
	}

	protected function validate() {
		if (!isset($this->request->post['username']) || !isset($this->request->post['password']) || !$this->posuser->login($this->request->post['username'], html_entity_decode($this->request->post['password'], ENT_QUOTES, 'UTF-8'))) {
			$this->error['warning'] = $this->language->get('error_login');
		}

		return !$this->error;
	}
}
