<?php
class ControllerExtensionTmdposPrintInvoice extends Controller {
	public function index() {
		$this->load->language('extension/tmdpos/printinvoice');
		$data['title'] = $this->language->get('text_invoice');

		if ($this->request->server['HTTPS']) {
			$data['base'] = HTTPS_SERVER;
		} else {
			$data['base'] = HTTP_SERVER;
		}

		$data['direction'] = $this->language->get('direction');
		$data['lang']      = $this->language->get('code');

		$data['text_invoice']           = $this->language->get('text_invoice');
		$data['text_order_detail']      = $this->language->get('text_order_detail');
		$data['text_order_id']          = $this->language->get('text_order_id');
		$data['text_invoice_no']        = $this->language->get('text_invoice_no');
		$data['text_invoice_date']      = $this->language->get('text_invoice_date');
		$data['text_date_added']        = $this->language->get('text_date_added');
		$data['text_telephone']         = $this->language->get('text_telephone');
		$data['text_fax']               = $this->language->get('text_fax');
		$data['text_email']             = $this->language->get('text_email');
		$data['text_website']           = $this->language->get('text_website');
		$data['text_payment_address']   = $this->language->get('text_payment_address');
		$data['text_shipping_address']  = $this->language->get('text_shipping_address');
		$data['text_payment_method']    = $this->language->get('text_payment_method');
		$data['text_shipping_method']   = $this->language->get('text_shipping_method');
		$data['text_comment']           = $this->language->get('text_comment');
		$data['text_cashier']           = $this->language->get('text_cashier');
		$data['text_code'] 				= $this->language->get('text_code');
		$data['text_qty'] 				= $this->language->get('text_qty');
		$data['text_description'] 		= $this->language->get('text_description');
		$data['text_price'] 			= $this->language->get('text_price');
		$data['text_due_date'] 			= $this->language->get('text_due_date');
		$data['text_apaid'] 			= $this->language->get('text_apaid');
		$data['text_adue'] 				= $this->language->get('text_adue');
		$data['text_customer'] 			= $this->language->get('text_customer');
		$data['column_product']         = $this->language->get('column_product');
		$data['column_model']           = $this->language->get('column_model');
		$data['column_quantity']        = $this->language->get('column_quantity');
		$data['column_price']           = $this->language->get('column_price');
		$data['column_total']           = $this->language->get('column_total');
		
		$store_url = $this->request->server['HTTPS'] ? HTTPS_SERVER : HTTP_SERVER;
		
		$data['name'] = $this->config->get('config_name');
		
		if (is_file(DIR_IMAGE . $this->config->get('config_logo'))) {
			 $data['storelogo'] = $store_url .'image/'.$this->config->get('config_logo');			
		} else {
			$data['storelogo'] = '';
		}

		$storelogo  = $this->config->get('setting_image');
		$logowidth  = $this->config->get('setting_logowidth');
		$logoheight = $this->config->get('setting_logoheight');

		if($logoheight) {
			$heights = $logoheight;
		} else {
			$heights = 200;
		}

		if($logowidth) {
			$widths = $logowidth;
		} else {
			$widths = 200;
		}
		$this->load->model('tool/image');
		if (!empty($storelogo)) {
			$data['storelogo'] = $this->model_tool_image->resize($storelogo, $logowidth, $logoheight);
		}else{
			$data['storelogo'] = '';
		}

		$receipt_width = $this->config->get('setting_receipt_width');
		
		if (!empty($receipt_width)) {
			$data['receipt_width'] = $receipt_width;
		}else{
			$data['receipt_width'] = 100;
		}

		
		$this->load->model('extension/tmdpos/order');

		$this->load->model('setting/setting');


		$orders = array();

		if (isset($this->request->get['order_id'])) {
			$order_id = $this->request->get['order_id'];
		} else  {
			$order_id = '';
		}

			$order_info = $this->model_extension_tmdpos_order->getOrder($order_id);
			
			if ($order_info) {
				$store_info = $this->model_setting_setting->getSetting('config', $order_info['store_id']);

				if ($store_info) {
					$store_address = $store_info['config_address'];
					$store_email = $store_info['config_email'];
					$store_telephone = $store_info['config_telephone'];
					$store_fax = $store_info['config_fax'];
				} else {
					$store_address = $this->config->get('config_address');
					$store_email = $this->config->get('config_email');
					$store_telephone = $this->config->get('config_telephone');
					$store_fax = $this->config->get('config_fax');
				}

				if ($order_info['invoice_no']) {
					$invoice_no = $order_info['invoice_prefix'] . $order_info['invoice_no'];
				} else {
					$invoice_no = '';
				}

				if ($order_info['payment_address_format']) {
					$format = $order_info['payment_address_format'];
				} else {
					$format = '{firstname} {lastname}' . "\n" . '{company}' . "\n" . '{address_1}' . "\n" . '{address_2}' . "\n" . '{city} {postcode}' . "\n" . '{zone}' . "\n" . '{country}';
				}

				$find = array(
					'{firstname}',
					'{lastname}',
					'{company}',
					'{address_1}',
					'{address_2}',
					'{city}',
					'{postcode}',
					'{zone}',
					'{zone_code}',
					'{country}'
				);

				$replace = array(
					'firstname' => $order_info['payment_firstname'],
					'lastname'  => $order_info['payment_lastname'],
					'company'   => $order_info['payment_company'],
					'address_1' => $order_info['payment_address_1'],
					'address_2' => $order_info['payment_address_2'],
					'city'      => $order_info['payment_city'],
					'postcode'  => $order_info['payment_postcode'],
					'zone'      => $order_info['payment_zone'],
					'zone_code' => $order_info['payment_zone_code'],
					'country'   => $order_info['payment_country']
				);

				$payment_address = str_replace(array("\r\n", "\r", "\n"), '<br />', preg_replace(array("/\s\s+/", "/\r\r+/", "/\n\n+/"), '<br />', trim(str_replace($find, $replace, $format))));

				if ($order_info['shipping_address_format']) {
					$format = $order_info['shipping_address_format'];
				} else {
					$format = '{firstname} {lastname}' . "\n" . '{company}' . "\n" . '{address_1}' . "\n" . '{address_2}' . "\n" . '{city} {postcode}' . "\n" . '{zone}' . "\n" . '{country}';
				}

				$find = array(
					'{firstname}',
					'{lastname}',
					'{company}',
					'{address_1}',
					'{address_2}',
					'{city}',
					'{postcode}',
					'{zone}',
					'{zone_code}',
					'{country}'
				);

				$replace = array(
					'firstname' => $order_info['shipping_firstname'],
					'lastname'  => $order_info['shipping_lastname'],
					'company'   => $order_info['shipping_company'],
					'address_1' => $order_info['shipping_address_1'],
					'address_2' => $order_info['shipping_address_2'],
					'city'      => $order_info['shipping_city'],
					'postcode'  => $order_info['shipping_postcode'],
					'zone'      => $order_info['shipping_zone'],
					'zone_code' => $order_info['shipping_zone_code'],
					'country'   => $order_info['shipping_country']
				);

				$shipping_address = str_replace(array("\r\n", "\r", "\n"), '<br />', preg_replace(array("/\s\s+/", "/\r\r+/", "/\n\n+/"), '<br />', trim(str_replace($find, $replace, $format))));

				$this->load->model('tool/upload');

				$data['products'] = array();

				$product_infos = $this->model_extension_tmdpos_order->getOrderProducts($order_id);

				foreach ($product_infos as $product) {
					$option_data = array();

					$options = $this->model_extension_tmdpos_order->getOrderOptions($order_id, $product['order_product_id']);

					foreach ($options as $option) {
						if ($option['type'] != 'file') {
							$value = $option['value'];
						} else {
							$upload_info = $this->model_tool_upload->getUploadByCode($option['value']);

							if ($upload_info) {
								$value = $upload_info['name'];
							} else {
								$value = '';
							}
						}

						$option_data[] = array(
							'name'  => $option['name'],
							'value' => $value
						);
					}

					$data['products'][] = array(
						'name'     => $product['name'],
						'model'    => $product['model'],
						'option'   => $option_data,
						'quantity' => $product['quantity'],
						'price'    => $this->currency->format($product['price'] + ($this->config->get('config_tax') ? $product['tax'] : 0), $order_info['currency_code'], $order_info['currency_value']),
						'total'    => $this->currency->format($product['total'] + ($this->config->get('config_tax') ? ($product['tax'] * $product['quantity']) : 0), $order_info['currency_code'], $order_info['currency_value'])
					);
				}

				// QR Work START
					if (!empty($this->config->get('setting_pos_qrshow'))) {
						$data['setting_pos_qrshow'] = $this->config->get('setting_pos_qrshow');
					}else{
						$data['setting_pos_qrshow'] = '';
					}

					require_once(DIR_SYSTEM.'library/tmd/Barcode/phpqrcode/qrlib.php');
					$qrcodeheight 	= $this->config->get('setting_qrcodeheight');
					$qrcodewidth 	= $this->config->get('setting_qrcodewidth');

			      	if(!empty($order_id)) {
			      		$filename='order_'.$order_id;
			      		$filename .='.png';
						$qrroot = DIR_IMAGE.'catalog/qrcode';
						if (!file_exists($qrroot)) {
							mkdir($qrroot);
						}
						$file_img= $qrroot.'/'.$filename;
						$httpath=HTTP_SERVER.'image/catalog/qrcode/'.$filename;
						$qrvalue = $this->url->link('extension/tmdpos/printinvoice','&order_id=' . $order_id, true);
						QRcode::png($qrvalue,$file_img);
					
						if(isset($qrcodeheight)) {
							$qrcodeheight = $qrcodeheight;
						} else {
							$qrcodeheight =40;
						}

						if(isset($qrcodewidth)) {
							$qrcodewidth = $qrcodewidth;
						} else {
							$qrcodewidth =40;
						}
						$data['qrposcode'] = "<div><img height='".$qrcodeheight."' width='".$qrcodewidth."' src='".$httpath."' /> </br></div>";

						$data['back']   = $this->url->link('extension/tmdpos/pos');

					}
				    // QR Work END

			

				$data['totals'] = array();

				$totals = $this->model_extension_tmdpos_order->getOrderTotals($order_id);

				foreach ($totals as $total) {
					$data['totals'][] = array(
						'title' => $total['title'],
						'text'  => $this->currency->format($total['value'], $order_info['currency_code'], $order_info['currency_value'])
					);
				}
				$ordercomment=explode(':',$order_info['comment']);
				
				$cardnumber='';
				
				if(isset($ordercomment[1]))
				{
				$cardnumber=' ('.$ordercomment[1].') ';
				}

				$users_info = $this->model_extension_tmdpos_order->getPosUser($order_id);
				

				if(isset($users_info['username'])) {
					$username= $users_info['username'];
				} else {
					$username='';
				}

				$this->load->model('extension/tmdpos/pos');
				$p_payments = array();
				$partial_sum = $this->model_extension_tmdpos_pos->getSumPartialpayments($order_id);
				$partial_results = $this->model_extension_tmdpos_pos->getPartialinvoices($order_id);
				if($partial_sum){
					foreach ($partial_results as $partial_result) {
						$p_payments[] = array(
						'partial_amount'    =>  $this->currency->format($partial_result['partial_amount'], $order_info['currency_code'], $order_info['currency_value']),
						'date_added'    => date($this->language->get('date_format_short'), strtotime($partial_result['date_added'])),
						);
					}
				}
					

					$payment_method='';
					$setting_paymentmethods = !empty($this->config->get('setting_paymentmethod'))?$this->config->get('setting_paymentmethod'):'';
					if(is_array($setting_paymentmethods)) {
						foreach ($setting_paymentmethods as $setting_paymentmethod) {
							if($setting_paymentmethod['code'] == $order_info['payment_method']) {
								$payment_method .= $setting_paymentmethod['name'];
							}
						}
					}

					$data['order_id']          = $order_id;
					$data['p_payments']        = $p_payments;
					$data['invoice_no']        = $invoice_no;
					$data['date_added']        = date($this->language->get('date_format_short'), strtotime($order_info['date_added']));
					$data['storename']         = $order_info['store_name'];
					$data['store_url']         =  rtrim($order_info['store_url'], '/');
					$data['storeaddress']      = nl2br($store_address);
					$data['store_email']   	   = $store_email;
					$data['storetelephone']    = $store_telephone;
					$data['store_fax']   	   = $store_fax;
					$data['username']   	   = $username;
					$data['customername']      = $order_info['firstname'].' '.$order_info['lastname'];
					$data['email']   	       = $order_info['email'];
					$data['telephone']   	   = $order_info['telephone'];
					$data['shipping_address']  = $shipping_address;
					$data['shipping_method']   = $order_info['shipping_method'];
					$data['payment_address']   = $payment_address;
					$data['payment_method']    = $payment_method.$cardnumber;
					$data['comment']   	       = nl2br($ordercomment[0]);
					$data['time']  		       = date('H:i A', strtotime($order_info['date_added']));
			}


		//paid amount
			$paidinfo = $this->model_extension_tmdpos_pos->getPaidpayment($order_id);
			
			if(!empty($paidinfo['paid_amount'])){
			    $data['paid_amount'] =$this->currency->format($paidinfo['paid_amount'], $order_info['currency_code']);
			}else{
				$data['paid_amount'] ='';
			}

			if(!empty($paidinfo['change_amount'])){
				$data['change_amount'] =$this->currency->format($paidinfo['change_amount'], $order_info['currency_code']);
			}else{
				$data['change_amount'] ='';
			}	

		/// Invoice Setting Start ///				
		$data['store_logo'] 		= $this->config->get('setting_store_logo');
		$data['store_name'] 		= $this->config->get('setting_store_name');
		$data['store_address'] 		= $this->config->get('setting_store_address');
		$data['store_telephone']	= $this->config->get('setting_store_telephone');
		$data['store_order_date'] 	= $this->config->get('setting_order_date');
		$data['store_order_time'] 	= $this->config->get('setting_order_time');
		$data['invoice_number'] 	= $this->config->get('setting_invoice_number');
		$data['cashier_name'] 		= $this->config->get('setting_cashier_name');
		$data['payment_mode'] 		= $this->config->get('setting_payment_mode');
		$data['shipping_mode'] 		= $this->config->get('setting_shipping_mode');
		$data['customer_name'] 		= $this->config->get('setting_customer_name');
		$data['payment_shipping_address'] 	= $this->config->get('setting_payment_shipping');
		$data['paid_amount_status'] 		= $this->config->get('setting_paid_amount');
		$data['change_amount_status'] 		= $this->config->get('setting_change_amount');
		$data['partial_status'] 		= $this->config->get('setting_partial_status');
		$data['split_status'] 		= $this->config->get('setting_split_status');
		/// Invoice Setting End 	
		
		$data['config_name'] = $this->config->get('config_name');
		$data['config_address'] = $this->config->get('config_address');
		$data['config_telephone'] = $this->config->get('config_telephone');
		$data['setting_invoice'] 	= !empty($this->config->get('setting_invoice'))?nl2br($this->config->get('setting_invoice')):'';
		$data['setting_extra'] 	= !empty($this->config->get('setting_extra'))?nl2br($this->config->get('setting_extra')):'';
		
		//cash status
		if($order_info['payment_method']=='cod'){
			$data['paid_cash_status'] = true;
		}else{
			$data['paid_cash_status'] = false;
		}

		//partpayment status
		if(!empty($order_info['total'])){
			$order_amount=$order_info['total'];
		}else{
			$order_amount=0;
		}

		$partialdue=$order_amount-$partial_sum;
		$data['partial_sum']=$partial_sum;
		$data['partial_due']=$this->currency->format($partialdue, $order_info['currency_code'], $order_info['currency_value']);

		if($order_info['payment_method']=='partpayment'){
		$partamount = $this->model_extension_tmdpos_pos->getPartialamount($order_id);
			$data['partialamount'] = $this->currency->format($partial_sum, $order_info['currency_code'], $order_info['currency_value']);
			$data['partpayment'] = true;
		}else{
			$data['partialamount'] = '';
			$data['partpayment'] = false;
		}


	  //split payment status
		if($order_info['payment_method']=='split'){
			$data['splitpayment'] = true;
		}else{
			$data['splitpayment'] = false;
		}

		$data['split_pay']=$this->currency->format($order_amount, $order_info['currency_code'], $order_info['currency_value']);
			
		$data['split_methods'] = array();
			$splitpayment_infos = $this->model_extension_tmdpos_pos->getSplitPaymentMethod($order_id);
			foreach ($splitpayment_infos as $splitpayment_info) {
				$data['split_methods'][]=array(
					'method' 			=> $splitpayment_info['method'],
					'amount' 			=> $this->currency->format($splitpayment_info['amount'], $this->config->get('config_currency'), $this->config->get('currency_value')),
				);
			}	

	
		if(!empty($this->config->get('setting_format'))) {
			$this->response->setOutput($this->load->view('extension/tmdpos/printinvoice1', $data));
		} else {
			$this->response->setOutput($this->load->view('extension/tmdpos/printinvoice', $data));
		}
		
	}
}