<?php
class ControllerExtensionTmdposReset extends Controller {
	private $error = array();

	public function index() {
		if ($this->posuser->isLogged()) {
			$this->response->redirect($this->url->link('extension/tmdpos/pos', '', true));
		}

		if (!$this->config->get('config_password')) {
			$this->response->redirect($this->url->link('extension/tmdpos/login', '', true));
		}
		
		$this->load->language('extension/tmdpos/reset');
		$this->load->model('extension/tmdpos/user');


		$data['heading_title']=$this->language->get('heading_title');
		$data['text_password']=$this->language->get('text_password');
		$data['entry_password']=$this->language->get('entry_password');
		$data['entry_confirm']=$this->language->get('entry_confirm');
		$data['button_save']=$this->language->get('button_save');
		$data['entry_email']=$this->language->get('entry_email');
		$data['button_reset']=$this->language->get('button_reset');
		$data['button_cancel']=$this->language->get('button_cancel');

	


		if (isset($this->request->get['code'])) {
			$code = $this->request->get['code'];
		} else {
			$code = '';
		}


		$user_info = $this->model_extension_tmdpos_user->getUserByCode($code);

		if ($user_info) {

			$this->document->setTitle($this->language->get('heading_title'));

			if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
				$this->model_extension_tmdpos_user->editPassword($user_info['user_id'], $this->request->post['password']);

				$this->session->data['success'] = $this->language->get('text_success');

				$this->response->redirect($this->url->link('extension/tmdpos/login', '', true));
			}

			$data['breadcrumbs'] = array();

			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_home'),
				'href' => $this->url->link('extension/tmdpos/pos', '', true)
			);

			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('heading_title'),
				'href' => $this->url->link('extension/tmdpos/reset', '', true)
			);

			if (isset($this->error['password'])) {
				$data['error_password'] = $this->error['password'];
			} else {
				$data['error_password'] = '';
			}

			if (isset($this->error['confirm'])) {
				$data['error_confirm'] = $this->error['confirm'];
			} else {
				$data['error_confirm'] = '';
			}

			$data['action'] = $this->url->link('extension/tmdpos/reset', 'code=' . $code, true);

			$data['cancel'] = $this->url->link('extension/tmdpos/login', '', true);

			if (isset($this->request->post['password'])) {
				$data['password'] = $this->request->post['password'];
			} else {
				$data['password'] = '';
			}

			if (isset($this->request->post['confirm'])) {
				$data['confirm'] = $this->request->post['confirm'];
			} else {
				$data['confirm'] = '';
			}

			$this->response->setOutput($this->load->view('extension/tmdpos/reset', $data));
		} else {
			
			return new Action('extension/tmdpos/login');
		}
	}

	protected function validate() {
		if ((utf8_strlen(html_entity_decode($this->request->post['password'], ENT_QUOTES, 'UTF-8')) < 4) || (utf8_strlen(html_entity_decode($this->request->post['password'], ENT_QUOTES, 'UTF-8')) > 40)) {
			$this->error['password'] = $this->language->get('error_password');
		}

		if ($this->request->post['confirm'] != $this->request->post['password']) {
			$this->error['confirm'] = $this->language->get('error_confirm');
		}

		return !$this->error;
	}
}