<?php
class ControllerExtensionTmdposReturnOrder extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/tmdpos/returnorder');
		$data['entry_order_id'] = $this->language->get('entry_order_id');
		$data['button_search'] = $this->language->get('button_search');
		$this->document->setTitle($this->language->get('heading_title'));
		$this->response->setOutput($this->load->view('extension/tmdpos/returnorder', $data));


		if(isset($this->request->get['tmd_order_id']))
		{
			$order_id= $this->request->get['tmd_order_id'];
		}
		else
		{
			$order_id= 0;
		}

		if(isset($this->request->get['filter_data']))
		{
			$data['filter_data']= $this->request->get['filter_data'];
		}
		else
		{
			$data['filter_data']= false;
		}

		$this->load->model('extension/tmdpos/returnorder');
		$this->load->model('tool/image');
		$order_info = $this->model_extension_tmdpos_returnorder->getOrder($order_id);
		


		$data['heading_title'] = $this->language->get('text_order');

		$data['entry_order_status'] = $this->language->get('entry_order_status');
		$data['text_order_detail'] = $this->language->get('text_order_detail');
		$data['column_image'] = $this->language->get('column_image');
		$data['text_invoice_no'] = $this->language->get('text_invoice_no');
		$data['text_order_id'] = $this->language->get('text_order_id');
		$data['text_date_added'] = $this->language->get('text_date_added');
		$data['text_shipping_method'] = $this->language->get('text_shipping_method');
		$data['text_shipping_address'] = $this->language->get('text_shipping_address');
		$data['text_payment_method'] = $this->language->get('text_payment_method');
		$data['text_payment_address'] = $this->language->get('text_payment_address');
		$data['text_history'] = $this->language->get('text_history');
		$data['text_comment'] = $this->language->get('text_comment');
		$data['text_no_results'] = $this->language->get('text_no_results');
		$data['text_order_not_found'] = $this->language->get('text_order_not_found');
		$data['error_quantity'] = $this->language->get('error_quantity');

		$data['column_name'] = $this->language->get('column_name');
		$data['column_reason'] = $this->language->get('column_reason');
		$data['column_model'] = $this->language->get('column_model');
		$data['column_quantity'] = $this->language->get('column_quantity');
		$data['column_price'] = $this->language->get('column_price');
		$data['column_total'] = $this->language->get('column_total');
		$data['column_action'] = $this->language->get('column_action');
		$data['column_date_added'] = $this->language->get('column_date_added');
		$data['column_status'] = $this->language->get('column_status');
		$data['column_comment'] = $this->language->get('column_comment');

		$data['button_update'] = $this->language->get('button_update');
		$data['button_return'] = $this->language->get('button_return');


		$data['action'] = $this->url->link('extension/tmdpos/returnorder/update', true);
		if ($order_info) 
		{
			
			$data['date_added'] = date($this->language->get('date_format_short'), strtotime($order_info['date_added']));
			

			$data['payment_address'] = $order_info['payment_firstname'].' '.$order_info['payment_lastname'].','.$order_info['payment_zone'].','.$order_info['payment_country'];

			$data['payment_method'] = $order_info['payment_method'];
			$data['shipping_method'] = $order_info['shipping_method'];

			$setting_returns = $this->config->get('setting_return');

			$data['settingreturns'] = array();

			if(is_array($setting_returns)) {
				foreach ($setting_returns as $reason) {
					$data['settingreturns'][] = array(
						'reason' 		=> $reason['setting_return_description'][$this->config->get('config_language_id')]['reason'],
					);
				}
			}

			$this->load->model('localisation/order_status');

			$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

			$this->load->model('catalog/product');
			$this->load->model('tool/upload');

			// Products
			$data['products'] = array();

			$products = $this->model_extension_tmdpos_returnorder->getOrderProducts($order_id);

			foreach ($products as $product) {
				$option_data = array();

				$options = $this->model_extension_tmdpos_returnorder->getOrderOptions($order_id, $product['order_product_id']);

				foreach ($options as $option) {
					if ($option['type'] != 'file') {
						$value = $option['value'];
					} else {
						$upload_info = $this->model_tool_upload->getUploadByCode($option['value']);

						if ($upload_info) {
							$value = $upload_info['name'];
						} else {
							$value = '';
						}
					}

					$option_data[] = array(
						'name'  => $option['name'],
						'value' => (utf8_strlen($value) > 20 ? utf8_substr($value, 0, 20) . '..' : $value)
					);
				}

				$product_info = $this->model_catalog_product->getProduct($product['product_id']);

				if ($product_info['image']) 
				{
					$image = $this->model_tool_image->resize($product_info['image'], 50, 50);
				} 
				else 
				{
					$image = $this->model_tool_image->resize('placeholder.png', 50, 50);
				}

				$data['products'][] = array(
					'image'     => $image,
					'order_product_id'	=> $product['order_product_id'],
					'product_id'	=> $product['product_id'],
					'order_id'	=> $product['order_id'],
					'name'     => $product['name'],
					'model'    => $product['model'],
					'option'   => $option_data,
					'quantity' => $product['quantity'],
					'price'    => $this->currency->format($product['price'] + ($this->config->get('config_tax') ? $product['tax'] : 0), $order_info['currency_code'], $order_info['currency_value']),
					'total'    => $this->currency->format($product['total'] + ($this->config->get('config_tax') ? ($product['tax'] * $product['quantity']) : 0), $order_info['currency_code'], $order_info['currency_value']),
				);
			}

			// Totals
			$data['totals'] = array();

			$totals = $this->model_extension_tmdpos_returnorder->getOrderTotals($order_id);

			foreach ($totals as $total) {
				$data['totals'][] = array(
					'title' => $total['title'],
					'text'  => $this->currency->format($total['value'], $order_info['currency_code'], $order_info['currency_value']),
				);
			}
		}
		$this->response->setOutput($this->load->view('extension/tmdpos/returnorder', $data));
	}
		
	public function update() 
	{	
		$json = '';
		$this->load->language('extension/tmdpos/returnorder');
		$this->load->model('extension/tmdpos/returnorder');
		$order_id = $this->model_extension_tmdpos_returnorder->addReturn($this->request->post);
		if (!empty($order_id)) {
			$json['success'] 	= $this->language->get('text_success2');
			$json['order_id'] 	= $order_id;
			$json['link'] 		= $this->url->link('extension/tmdpos/returnorder/returnPrint','&order_id='.$order_id, true);
		}
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}

	public function returnPrint() {
		$this->load->model('extension/tmdpos/return_report');
		$this->load->language('extension/tmdpos/return_report');
		$this->load->model('tool/upload');

		$this->document->setTitle($this->language->get('text_return'));
		
		$data['storelogo'] ='';
		$storelogo = $this->config->get('setting_image');
		$logowidth = $this->config->get('setting_logowidth');
		$logoheight = $this->config->get('setting_logoheight');

		if($logoheight) {
			$heights = $logoheight;
		} else {
			$heights = 200;
		}

		if($logowidth) {
			$widths = $logowidth;
		} else {
			$widths = 200;
		}


		$this->load->model('tool/image');
		if (!empty($storelogo)) {
			$data['storelogo'] = $this->model_tool_image->resize($storelogo, $heights, $widths);
		}else {
			$data['storelogo'] = $this->model_tool_image->resize('placeholder.png',$heights,$widths);
		}

		
		$data['config_name'] = $this->config->get('config_name');
		$data['config_address'] = $this->config->get('config_address');
		$data['config_telephone'] = $this->config->get('config_telephone');
		$data['config_email'] = $this->config->get('config_email');

		$this->load->model('setting/setting');
		if (!empty($this->session->data['store_id'])) {
			$store_info = $this->model_setting_setting->getSetting('config', $this->session->data['store_id']);
			if (!empty($store_info)) {
				$data['config_name'] 	=$store_info['config_name'];
				$data['config_address'] 	=$store_info['config_address'];
				$data['config_telephone'] 	=$store_info['config_telephone'];
				$data['config_email'] 	=$store_info['config_email'];

				if (!empty($store_info['config_image']) && is_file(DIR_IMAGE . $store_info['config_image'])) {
					$data['storelogo'] = $this->model_tool_image->resize($store_info['config_image'], $widths, $heights);
				}else {
					$data['storelogo'] = $this->model_tool_image->resize('placeholder.png',$widths,$heights);
				}





			}
		}

		$data['entry_order_date'] = $this->language->get('entry_order_date');
		$data['text_return'] = $this->language->get('text_return');
		$data['text_return_id'] = $this->language->get('text_return_id');
		$data['entry_name'] = $this->language->get('entry_name');
		$data['entry_model'] = $this->language->get('entry_model');
		$data['entry_quantity'] = $this->language->get('entry_quantity');
		$data['entry_price'] = $this->language->get('entry_price');
		$data['column_total'] = $this->language->get('column_total');
		$data['column_customer'] = $this->language->get('column_customer');
		$data['text_telephone'] = $this->language->get('text_telephone');
		$data['text_email'] = $this->language->get('text_email');
		$data['entry_reason'] = $this->language->get('entry_reason');
		$data['entry_date_added'] = $this->language->get('entry_date_added');
		$data['entry_order_id'] = $this->language->get('entry_order_id');

		$data['text_grand_total'] = $this->language->get('text_grand_total');

		if (isset($this->request->get['order_id'])) {
			$order_id = $this->request->get['order_id'];
		} else {
			$order_id = 0;
		}

		if (isset($this->request->get['return_id'])) {
			$return_id = $this->request->get['return_id'];
		} else {
			$return_id = null;
		}
		$filter_data = array(
			'filter_return_id' => $return_id,
			'filter_order_id' => $order_id,
		);
		$total = 0;
		$data['products'] = array();
		$return_infos = $this->model_extension_tmdpos_return_report->getReports($filter_data);
		foreach ($return_infos as $key => $result) {
			$option_data = array();
			$options = $this->model_extension_tmdpos_return_report->getOrderOptions($result['order_id'], $result['order_product_id']);
			foreach ($options as $option) {
				if ($option['type'] != 'file') {
					$value = $option['value'];
				} else {
					$upload_info = $this->model_tool_upload->getUploadByCode($option['value']);

					if ($upload_info) {
						$value = $upload_info['name'];
					} else {
						$value = '';
					}
				}

				$option_data[] = array(
					'name'  => $option['name'],
					'value' => (utf8_strlen($value) > 20 ? utf8_substr($value, 0, 20) . '..' : $value),
					'type'  => $option['type']
				);
			}
			$total += $result['quantity']*$result['price'];
			$data['products'][] = array(
				'option'    		=> $option_data,
				'product_id'		=> $result['product_id'],
				'order_id'			=> $result['order_id'],
				'name' 				=> $result['name'],
				'model' 			=> $result['model'],
				'reason' 			=> $result['reason'],
				'quantity'  		=> $result['quantity'],
				'date_added'  		=> $result['date_added'],
				'price' 			=> $this->currency->format($result['price'], $this->session->data['currency']),
				'total' 			=> $this->currency->format($result['quantity']*$result['price'], $this->session->data['currency']),
			);
		}
		$data['grand_total'] = $this->currency->format($total, $this->session->data['currency']);
		$customer_id 				= !empty($order_id)?$order_id:'0';
		$order_info 				= $this->model_extension_tmdpos_return_report->getOrder($order_id);
		$data['customername']     	= !empty($order_info['firstname'])?$order_info['firstname'].' '.$order_info['lastname']:'NA';
		$data['order_id'] 			= !empty($order_id)?$order_id:'0';
		$data['invoice_no'] 		= !empty($order_info['invoice_no'])?$order_info['invoice_no']:'';
		$data['date_added'] 		= !empty($order_info['date_added'])? date('Y-m-d',strtotime($order_info['date_added'])):'NA';
		if(!empty($this->config->get('setting_format'))) {
			$this->response->setOutput($this->load->view('extension/tmdpos/returnprintinvoice2', $data));
		} else {
			$this->response->setOutput($this->load->view('extension/tmdpos/returnprintinvoice', $data));
		}
	}
}
