<?php
class ControllerExtensionTmdposSelectCustomer extends Controller {
	private $error = array();

	public function index() {
		$this->load->model('extension/tmdpos/order');
		$this->load->language('extension/tmdpos/pos');
		$data['entry_customer'] = $this->language->get('entry_customer');
		$data['button_save'] = $this->language->get('button_save');
		$this->document->setTitle($this->language->get('heading_title'));

		$data['newadd'] = $this->url->link('extension/tmdpos/paynowcustomer', true);

		$this->response->setOutput($this->load->view('extension/tmdpos/selectcustomer', $data));


	}

	public function edit() 	{
		$json=array();
		$filter_data = array();
		$this->load->model('extension/tmdpos/customer');
		$this->load->model('extension/tmdpos/customerproduct');
		$this->load->model('tool/image');
		$this->load->language('extension/tmdpos/pos');
		if(isset($this->request->post))
		{	unset($this->session->data['pos_customer_id']);
			$this->session->data['pos_customer_id']=$this->request->post['customer_id'];
			
			$customer_info = $this->model_extension_tmdpos_customer->getCustomer($this->request->post['customer_id']);
			$this->session->data['pos_customer_group_id']=$customer_info['customer_group_id'];
			
			$results = $this->model_extension_tmdpos_customerproduct->getProducts($filter_data);
			$display_customer_pro = $this->config->get('setting_display_customer_pro');
			if ($display_customer_pro ==1)
			{
				$json['products'] = array();
				foreach ($results as $result)
				{

				$imageheight = $this->config->get('setting_imageheight');
      			$imagewidth = $this->config->get('setting_imagewidth');
				if($imageheight) {
					$heights = $imageheight;
				} else {
					$heights = 200;
				}

				if($imagewidth) {
					$widths = $imagewidth;
				} else {
					$widths = 200;
				}
				if ($result['image']) {
					$image = $this->model_tool_image->resize($result['image'],$heights,$widths);
				} else {
					$image = $this->model_tool_image->resize('placeholder.png',$heights,$widths);
				}

					

					if(isset($result['price']))
					{
						$price = $this->currency->format($result['price'], $this->session->data['currency']);
					}
					else
					{
						$price =  false;
					}

					$percentage=0;

					if ((float)$result['special'])
					{
						$percentage=round(100-(($result['special']/$result['price'])*100),2);
						$special = $this->currency->format($this->tax->calculate($result['special'], $result['tax_class_id'], $this->config->get('config_tax')), $this->session->data['currency']);
					}
					else
					{
						$special = false;
					}

					if ($this->config->get('config_tax'))
					{
						$tax = $this->currency->format((float)$result['special'] ? $result['special'] : $result['price'], $this->session->data['currency']);
					}
					else
					{
						$tax = false;
					}

					if ($this->config->get('config_review_status'))
					{
						$rating = (int)$result['rating'];
					}
					else
					{
						$rating = false;
					}

					$options ='';

					foreach ($this->model_extension_tmdpos_pos->getProductOptions($result['product_id']) as $option)
					{
						$product_option_value_data = array();

						foreach ($option['product_option_value'] as $option_value)
						{

							if ((($this->config->get('config_customer_price') && $this->customer->isLogged()) || !$this->config->get('config_customer_price')) && (float)$option_value['price'])
							{
								$price = $this->currency->format($option_value['price'], $this->session->data['currency']);
							}
							else
							{
								$price = false;
							}
							$options.=$option_value['name'].'-'.$option_value['quantity'].',';
						}
					}

					$json['products'][] = array(
						'product_id'  => $result['product_id'],
						'thumb'       => $image,
						'name'        => $result['name'],
						'description' => utf8_substr(strip_tags(html_entity_decode($result['description'], ENT_QUOTES, 'UTF-8')), 0, $this->config->get($this->config->get('config_theme') . '_product_description_length')) . '..',
						'price'       => $price,
						'special'     => $special,
						'tax'         => $tax,
						'options'         => $options,
						'stock'         => $result['quantity'],
						'percentage'         => $percentage,
						'minimum'     => $result['minimum'] > 0 ? $result['minimum'] : 1,
					);
				}
			}
			$json['success']=$this->language->get('button_save');
		}
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
}
