<?php
class ModelExtensionTmdposUser extends Model {
	public function addUser($data) {
		$this->db->query("INSERT INTO `" . DB_PREFIX . "pos_user` SET 
		username = '" . $this->db->escape($data['username']) . "',
		store_id = '0',
		user_store_id = '" . (int)$data['user_store_id'] . "',
		user_group_id = '" . (int)$data['user_group_id'] . "',
		salt = '" . $this->db->escape($salt = token(9)) . "',
		password = '" . $this->db->escape(sha1($salt . sha1($salt . sha1($data['password'])))) . "',
		firstname = '" . $this->db->escape($data['firstname']) . "',
		lastname = '" . $this->db->escape($data['lastname']) . "',
		email = '" . $this->db->escape($data['email']) . "',
		image = '" . $this->db->escape($data['image']) . "',
		status = '" . (int)$data['status'] . "',
		commission = '".$this->db->escape($data['commission'])."',
		commission_value='".(int)$data['commission_value']."',
		date_added = NOW()");
	
		return $this->db->getLastId();
	}

	public function editUser($user_id, $data) {
		$this->db->query("UPDATE `" . DB_PREFIX . "pos_user` SET 
		username = '" . $this->db->escape($data['username']) . "',
		store_id = '0',user_store_id = '" . (int)$data['user_store_id'] . "',
		user_group_id = '" . (int)$data['user_group_id'] . "',
		firstname = '" . $this->db->escape($data['firstname']) . "',
		lastname = '" . $this->db->escape($data['lastname']) . "',
		email = '" . $this->db->escape($data['email']) . "',
		image = '" . $this->db->escape($data['image']) . "',
		status = '" . (int)$data['status'] . "',
		commission = '".$this->db->escape($data['commission'])."',
		commission_value='".(int)$data['commission_value']."' WHERE user_id = '" . (int)$user_id . "'");

		if ($data['password']) {
			$this->db->query("UPDATE `" . DB_PREFIX . "pos_user` SET 
			salt = '" . $this->db->escape($salt = token(9)) . "',
			password = '" . $this->db->escape(sha1($salt . sha1($salt . sha1($data['password'])))) . "' WHERE user_id = '" . (int)$user_id . "'");
		}
	}

	public function editPassword($user_id, $password) {
		$this->db->query("UPDATE `" . DB_PREFIX . "pos_user` SET 
		salt = '" . $this->db->escape($salt = token(9)) . "',
		password = '" . $this->db->escape(sha1($salt . sha1($salt . sha1($password)))) . "',
		code = '' WHERE user_id = '" . (int)$user_id . "'");
	}

	public function editCode($email, $code) {
		$this->db->query("UPDATE `" . DB_PREFIX . "pos_user` SET 
		code = '" . $this->db->escape($code) . "' WHERE LCASE(email) = '" . $this->db->escape(utf8_strtolower($email)) . "'");
		
		/// mail ///
			$this->load->language('mail/forgotten');
			$password = str_replace('&amp;', '&', $this->url->link('extension/tmdpos/reset', 'code=' . $code, true));

			$message  = sprintf($this->language->get('text_greeting'), html_entity_decode($this->config->get('config_name'), ENT_QUOTES, 'UTF-8')) . "\n\n";
			$message .= $this->language->get('text_change') . "\n\n";
			$message .= $password;


			$mail = new Mail($this->config->get('config_mail_engine'));
			$mail->parameter = $this->config->get('config_mail_parameter');
			$mail->smtp_hostname = $this->config->get('config_mail_smtp_hostname');
			$mail->smtp_username = $this->config->get('config_mail_smtp_username');
			$mail->smtp_password = html_entity_decode($this->config->get('config_mail_smtp_password'), ENT_QUOTES, 'UTF-8');
			$mail->smtp_port = $this->config->get('config_mail_smtp_port');
			$mail->smtp_timeout = $this->config->get('config_mail_smtp_timeout');

			$mail->setTo($email);
			$mail->setFrom($this->config->get('config_email'));
			$mail->setSender(html_entity_decode($this->config->get('config_name'), ENT_QUOTES, 'UTF-8'));
			$mail->setSubject(html_entity_decode(sprintf($this->language->get('text_subject'), html_entity_decode($this->config->get('config_name'), ENT_QUOTES, 'UTF-8')), ENT_QUOTES, 'UTF-8'));
			$mail->setText($message);
			$mail->send();
		/// mail ///
	}

	

	public function getUser($user_id) {
		$sql="select * from " . DB_PREFIX . "pos_user where user_id='".$user_id."'";
		$query=$this->db->query($sql);
		return $query->row;
	}

	public function getUserByUsername($username) {
		$query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "pos_user` 
		WHERE username = '" . $this->db->escape($username) . "'");

		return $query->row;
	}

	public function getUserByEmail($email) {
		$query = $this->db->query("SELECT DISTINCT * FROM `" . DB_PREFIX . "pos_user` 
		WHERE LCASE(email) = '" . $this->db->escape(utf8_strtolower($email)) . "'");

		return $query->row;
	}

	public function getUserByCode($code) {
		$query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "pos_user` 
		WHERE code = '" . $this->db->escape($code) . "' AND code != ''");

		return $query->row;
	}

	

	public function getTotalUsersByEmail($email) {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM `" . DB_PREFIX . "pos_user` 
		WHERE LCASE(email) = '" . $this->db->escape(utf8_strtolower($email)) . "'");

		return $query->row['total'];
	}
	
		public function getTotalUsers($data) {
		$sql = "SELECT COUNT(*) AS total FROM " . DB_PREFIX . "pos_user where user_id<>0";
		if (isset($data['filter_store']))
		{
		 $sql .=" and store_id like '".$this->db->escape($data['filter_store'])."%'";
		}

		if (!empty($data['filter_user_id']))
		{
		 $sql .=" and user_id = '".(int)$data['filter_user_id']."'";
		}
		$query = $this->db->query($sql);
		return $query->row['total'];
	}
	
}